unit ChooseThreeDeeModelForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, F8OpenGL, F8GLUtils;

type
  TCreateModelEvent = procedure (modelIndex: Integer) of object;

  TChooseThreeDeeModel = class(TForm)
    ThreeDeeModelList: TListBox;
    Send: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ThreeDeeModelListClick(Sender: TObject);
    procedure SendClick(Sender: TObject);
  private
    { Private declarations }
    FOnCreateModel: TCreateModelEvent;
    FCurrentIndex: Integer;
  public
    { Public declarations }
    constructor Create;
    destructor Destroy;

    property OnCreateModel: TCreateModelEvent read FOnCreateModel write FOnCreateModel;
  end;

  TThreeDeeModelIndex = class
  public
    index: Integer;
    constructor Create(num: Integer);
  end;

function hasWord(value: String): Boolean;

var
  ChooseThreeDeeModel: TChooseThreeDeeModel;

implementation

{$R *.dfm}

uses
  ModelSyncPluginMain,
  MS_Operation,
  PluginCore;

constructor TChooseThreeDeeModel.Create;
  begin
    Inherited Create(nil);
    FOnCreateModel:= nil;
    FCurrentIndex:= -1;
  end;

constructor TThreeDeeModelIndex.Create(num: Integer);
  begin
    index:= num;
  end;

destructor TChooseThreeDeeModel.Destroy;
  begin
    FOnCreateModel:= nil;
    FCurrentIndex:= 0;
    Inherited Destroy;
  end;

procedure TChooseThreeDeeModel.FormCreate(Sender: TObject);
  var
    project: IF8ProjectForRoad;
    dataLength: Integer;
    i: Integer;
    description: String;
  begin
    project:= ModelSyncPlugin.winRoadApplication.project;
    if Assigned(project) then begin
      dataLength:= project.numberOfThreeDModels;
      for i := 1 to dataLength do
        begin
          description:= project.threeDModel[i].name;
          //if (not (description[1] in ['a'..'z'])) and (not (description[1] in ['A'..'Z'])) then begin
          if (description[1] = '#') then begin
            //if not hasWord(description[1]) then
              ThreeDeeModelList.AddItem(description,TThreeDeeModelIndex.Create(i));
          end;
        end;
    end;
  end;

procedure TChooseThreeDeeModel.SendClick(Sender: TObject);
  begin
    if Assigned(FOnCreateModel) then
      FOnCreateModel(FCurrentIndex);
    self.Hide;
  end;

procedure TChooseThreeDeeModel.ThreeDeeModelListClick(Sender: TObject);
  begin
    FCurrentIndex:= TThreeDeeModelIndex(ThreeDeeModelList.Items.Objects[ThreeDeeModelList.ItemIndex]).index;
  end;

function  hasWord(value: String): Boolean;
  var
    str,s,sj: String;
    i: integer;
  begin
    str := trim(value);
    i := 1;
    while i<= Length(str) do
    begin
      if ord(str[i]) > $7F then
      begin
        result:= true;
        Exit;
      end
      else  i:=i+1;
    end;
    result:= false;
  end;

end.
