unit ConfigRoadObstructionForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, PluginCore, MS_Operation;

type

TCreateObstructionEvent = procedure (length: Double; leftLanes,rightLanes: TBooleanArray) of object;

  TConfigRoadObstruction = class(TForm)
    Label1: TLabel;
    ELength: TEdit;
    CheckBox4: TCheckBox;
    Send: TButton;
    CLane3: TCheckBox;
    CLane2: TCheckBox;
    CLane4: TCheckBox;
    CDirection: TComboBox;
    Label2: TLabel;
    procedure SendClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
    FOnCreateObstruction: TCreateObstructionEvent;
  public
    { Public declarations }
    constructor Create;
    destructor Destroy;

    property OnCreateObStruction: TCreateObstructionEvent read FOnCreateObstruction write FOnCreateObstruction;
  end;

var
  ConfigRoadObstruction: TConfigRoadObstruction;

implementation

{$R *.dfm}

constructor TConfigRoadObstruction.Create;
  begin
    Inherited Create(nil);
    FOnCreateObstruction:= nil;
  end;

destructor TConfigRoadObstruction.Destroy;
  begin
    Inherited Destroy;
    FOnCreateObstruction:= nil;
  end;

procedure TConfigRoadObstruction.FormShow(Sender: TObject);
  begin
    CDirection.AddItem('󳵵',nil);
    CDirection.AddItem('ҳ',nil);
    CDirection.ItemIndex:= 0;
  end;

procedure TConfigRoadObstruction.FormHide(Sender: TObject);
  begin
    CDirection.Clear;
  end;

procedure TConfigRoadObstruction.SendClick(Sender: TObject);
  var
    leftLanes: TBooleanArray;
    rightLanes: TBooleanArray;
  begin
    SetLength(leftLanes, 4);
    SetLength(rightLanes, 4);

    leftLanes[0]:= (CLane4.Checked) and (CDirection.ItemIndex = 1);
    leftLanes[1]:= (CLane3.Checked) and (CDirection.ItemIndex = 1);
    leftLanes[2]:= (CLane2.Checked) and (CDirection.ItemIndex = 1);
    //leftLanes[3]:= (CLane1.Checked) and (CDirection.ItemIndex = 1);
    rightLanes[0]:= (CLane4.Checked) and (CDirection.ItemIndex = 0);
    rightLanes[1]:= (CLane3.Checked) and (CDirection.ItemIndex = 0);
    rightLanes[2]:= (CLane2.Checked) and (CDirection.ItemIndex = 0);
    //rightLanes[3]:= (CLane1.Checked) and (CDirection.ItemIndex = 0);

    if (ELength.Text = '') then begin
      ShowMessage('Null Input');
      Exit;
    end;
    if Assigned(FOnCreateObstruction) then
      FOnCreateObstruction(StrToFloat(ELength.Text), rightLanes, leftLanes);
    self.Hide;
  end;

end.
