unit DeleteRoadObstructionForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, PluginCore;

type
TDeleteObstructionEvent = procedure (obIndex: Integer) of object;

  TDeleteRoadObstruction = class(TForm)
    RoadObstructionList: TListBox;
    Send: TButton;
    procedure SendClick(Sender: TObject);
    procedure RoadObstructionListClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
    FCurrentIndex: Integer;
    FRoad: IF8Road;
    FOnDeleteObstruction: TDeleteObstructionEvent;
  public
    { Public declarations }
    constructor Create;
    destructor Destroy;

    property Road: IF8Road read FRoad write FRoad;
    property OnDeleteObstruction: TDeleteObstructionEvent read FOnDeleteObstruction write FOnDeleteObstruction;
  end;

var
  DeleteRoadObstruction: TDeleteRoadObstruction;

implementation

uses
  MS_Operation,
  ModelSyncPluginMain;

{$R *.dfm}

constructor TDeleteRoadObstruction.Create;
  begin
    Inherited Create(nil);
    FRoad:= nil;
    FCurrentIndex:= -1;
    FOnDeleteObstruction:= nil;
  end;

destructor TDeleteRoadObstruction.Destroy;
  begin
    Inherited Destroy;
    FRoad:= nil;
    FCurrentIndex:= 0;
    FOnDeleteObstruction:= nil;
  end;

procedure TDeleteRoadObstruction.FormShow(Sender: TObject);
  var
    i: Integer;
    dataLength: Integer;
  begin
    if Assigned(road) then begin
      dataLength:= road.numberOfObstructions;
      for i := 1 to dataLength do begin
        RoadObstructionList.AddItem(road.name + ': ' + road.obstruction[i].description, nil);
      end;
    end;
  end;

procedure TDeleteRoadObstruction.FormHide(Sender: TObject);
  begin
    RoadObstructionList.Clear;
    FRoad:= nil;
    FCurrentIndex:= -1;
  end;

procedure TDeleteRoadObstruction.RoadObstructionListClick(Sender: TObject);
  begin
    FCurrentIndex:= RoadObstructionList.ItemIndex + 1;
  end;

procedure TDeleteRoadObstruction.SendClick(Sender: TObject);
  var
    requestOperation: TBaseOperation;
  begin
    if Assigned(FOnDeleteObstruction) then
      FOnDeleteObstruction(FCurrentIndex);
    self.Hide;
  end;

end.
