unit MS_Generator;
// =============================================================================
// ¼Ҫع
// =============================================================================
interface

uses
  PluginCore,
  Classes,
  F8OpenGL,
  F8GLUtils,
   MS_Operation,
  ModelSyncUtil;

type

TMSEvent = (NoEvent, ModelOperationEvent, RoadOperationEvent, TerrainOperationEvent);

// 
// Աб
// ========= p_KeyList水Ϣ
// ========= p_ModelSelectedǰѡеģʵ
// ========= p_PointSelectedǰѡе
// ========= p_EventSelectedǰ¼
TModelSyncGenerator = class(TObject)
  private
    p_KeyList: array of Word;

    p_ModelSelected: Integer;
    p_ModelSelectedType: Byte;
    p_ModelSelectedYawAngle: Double;

    p_PointSelected: GLPointType;
    p_EventSelected: TMSEvent;
    p_RoadSelected: IF8Road;
    p_RoadDistance: Double;

    p_Socket: TMSTCPClientSocket;

  public
    constructor Create;
    destructor Destroy;
    // ¼
    procedure MS_Keyup(sender: TObject; var key: Word; shift: TShiftState);
    // °¼
    procedure MS_KeyDown(sender: TObject; var key: Word; shift: TShiftState);
    // ģ¼
    function MS_ModelOperationClick(modelInstance: IF8Instance): Boolean;
    // ·¼
    function MS_RoadOperationClick(const road: IF8Road; const distance,
              offset: double; const leftSide, carriageway: boolean): boolean;
    // ¼
    procedure MS_TerrainOperationClick(const clickedPoint : GLPointType;
    const terrainTriangle : F8TriangleType; var command : ModelSelectCommandType);

    procedure MS_CreateModelClick(modelIndex: Integer);
    procedure MS_CreateObstructionClick(Length: Double; leftLanes,rightLanes: TBooleanArray);
    procedure MS_DeleteObstructionClick(obIndex: Integer);
    procedure MS_CommandHandleClick(modelInstance, commandIndex: Integer; modelInstanceType, commandType: Byte);

    property Handle: TMSTCPClientSocket read p_Socket write p_Socket;
  end;

function isnum(str:string):boolean;

implementation

uses
  Vcl.Dialogs,
  SysUtils,
  ChooseThreeDeeModelForm,
  ConfigRoadObstructionForm,
  DeleteRoadObstructionForm,
  ModelSyncPluginMain,
  ModelSyncCommandForm,
  MS_Parser;

const
  COMMAND_A         = 65;
  COMMAND_D         = 68;
  COMMAND_E         = 69;
  COMMAND_F         = 70;
  COMMAND_Q         = 81;
  COMMAND_S         = 83;
  COMMAND_W         = 87;

// Ĺ캯
constructor TModelSyncGenerator.Create;
  begin
    Inherited Create;
    SetLength(p_KeyList,0);
    p_ModelSelected:= -1;
    p_ModelSelectedType:= 0;
    p_ModelSelectedYawAngle:= 0.0;
    p_EventSelected:= NoEvent;
    p_RoadSelected:= nil;
    p_RoadDistance:= 0.0;

    if not Assigned(p_Socket) then
      p_Socket:= TMSTCPClientSocket.Create;

    if Assigned(ModelCommandForm) then
      ModelCommandForm.onHandle:=  MS_CommandHandleClick;
  end;

destructor TModelSyncGenerator.Destroy;
  begin
    Inherited Destroy;
    SetLength(p_KeyList,0);
    p_ModelSelected:= 0;
    p_ModelSelectedType:= 0;
    p_ModelSelectedYawAngle:= 0.0;
    p_RoadSelected:= nil;
    p_RoadDistance:= 0.0;
    p_EventSelected:= NoEvent;
    FreeAndNil(p_PointSelected);

    FreeAndNil(p_Socket);
  end;

// ̧𰴼
procedure TModelSyncGenerator.MS_Keyup(sender: TObject; var key: Word; shift: TShiftState);
  var
    i: Integer;
    j: Integer;
  begin
    for i:= 0 to High(p_keyList) do begin
      if p_KeyList[i] = key then begin
        for j := i to High(p_KeyList) - 1 do
            p_KeyList[j] := p_KeyList[j+1];
        SetLength(p_KeyList, Length(p_KeyList) - 1);
        Break;
      end;
    end;
  end;

//==============================================================================

procedure TModelSyncGenerator.MS_CreateModelClick(modelIndex: Integer);
  var
    i: Integer;
    requestOperation: TBaseOperation;
    parser: TMSOperationParser;
    sendBuf: Array [0..99] of Byte;
  begin
    parser:= TMSOperationParser.Create;
    requestOperation:= TCreateModelOperation.Create(p_PointSelected, modelIndex);
    parser.ToByteArray(requestOperation);
    if p_Socket.Connected then begin
      for I := 0 to 99 do
        sendBuf[i]:= parser.Buffer[i];
      p_Socket.Send(sendBuf, 100, 0);
    end;
  end;

procedure TModelSyncGenerator.MS_CommandHandleClick(modelInstance: Integer; commandIndex: Integer; modelInstanceType: Byte; commandType: Byte);
  var
    i: Integer;
    requestOperation: TBaseOperation;
    parser: TMSOperationParser;
    sendBuf: Array [0..99] of Byte;
  begin
    parser:= TMSOperationParser.Create;
    requestOperation:= TCommandOperation.Create(commandType,modelInstanceType,modelInstance,commandIndex);
    parser.ToByteArray(requestOperation);
    if p_Socket.Connected then begin
      for I := 0 to 99 do
        sendBuf[i]:= parser.Buffer[i];
      p_Socket.Send(sendBuf, 100, 0);
    end;
  end;

procedure TModelSyncGenerator.MS_CreateObstructionClick(Length: Double; leftLanes: TBooleanArray; rightLanes: TBooleanArray);
  var
    i: Integer;
    requestOperation: TBaseOperation;
    parser: TMSOperationParser;
    sendBuf: Array [0..99] of Byte;
  begin
    parser:= TMSOperationParser.Create;
    requestOperation:= TCreateObstructionOperation.Create(p_roadSelected.ID, 40,
                                                          p_roadDistance, length, 10, 200,
                                                          leftlanes, rightlanes);
    parser.ToByteArray(requestOperation);
    if p_Socket.Connected then begin
      for I := 0 to 99 do
        sendBuf[i]:= parser.Buffer[i];
      p_Socket.Send(sendBuf, 100, 0);
    end;
  end;

procedure TModelSyncGenerator.MS_DeleteObstructionClick(obIndex: Integer);
  var
    i: Integer;
    requestOperation: TBaseOperation;
    parser: TMSOperationParser;
    sendBuf: Array [0..99] of Byte;
  begin
    parser:= TMSOperationParser.Create;
    requestOperation:= TDeleteObstructionOperation.Create(obIndex,p_roadSelected.ID);
    parser.ToByteArray(requestOperation);
    if p_Socket.Connected then begin
      for I := 0 to 99 do
        sendBuf[i]:= parser.Buffer[i];
      p_Socket.Send(sendBuf, 100, 0);
    end;
  end;

// °ڵǰ¼ĲͬӦ¼
procedure TModelSyncGenerator.MS_KeyDown(sender: TObject; var key: Word; shift: TShiftState);
  var
    i: Integer;
    requestOperation: TBaseOperation;
    parser: TMSOperationParser;
    sendBuf: Array [0..99] of Byte;
  begin
    for i := 0 to High(p_KeyList) do begin
      if p_KeyList[i] = key then begin
        Exit;
      end;
    end;
    SetLength(p_KeyList, Length(p_KeyList) + 1);
    p_KeyList[High(p_KeyList)]:= key;

    // жϴǸ¼
    case p_EventSelected of

      NoEvent:
        begin
//          showmessage('No Event');
        end;

      ModelOperationEvent:
        begin
          if Length(p_KeyList) = 1 then begin
            if p_KeyList[0] = COMMAND_D then begin
//              showmessage('Delete Model');
              requestOperation:= TDeleteModelOperation.Create(p_ModelSelected,p_ModelSelectedType);
              p_ModelSelected:= -1;
              p_ModelSelectedType:= 0;
              parser:= TMSOperationParser.Create;
              parser.ToByteArray(requestOperation);
              if p_Socket.Connected then begin
                for I := 0 to 99 do
                  sendBuf[i]:= parser.Buffer[i];
                p_Socket.Send(sendBuf, 100, 0);
              end;
              p_EventSelected:= NoEvent;
            end
            else if p_KeyList[0] = COMMAND_W then begin
//              showmessage('Rotate Model');
              p_ModelSelectedYawAngle:= p_ModelSelectedYawAngle + 0.5;
              requestOperation:= TRotateModelOperation.Create(p_ModelSelected,p_ModelSelectedType,p_ModelSelectedYawAngle);
              parser:= TMSOperationParser.Create;
              parser.ToByteArray(requestOperation);
              if p_Socket.Connected then begin
                for I := 0 to 99 do
                  sendBuf[i]:= parser.Buffer[i];
                p_Socket.Send(sendBuf, 100, 0);
              end;
            end
            else if p_KeyList[0] = COMMAND_S then begin
//              showmessage('Set Accident Location');
            end;
          end;
        end;

      RoadOperationEvent:
        begin
          if Length(p_KeyList) = 1 then begin
            if p_KeyList[0] = COMMAND_S then begin
//              showmessage('Create Model On Road');
              if not Assigned(ChooseThreeDeeModel) then
                ChooseThreeDeeModel:= TChooseThreeDeeModel.Create;
              ChooseThreeDeeModel.OnCreateModel:= MS_CreateModelClick;
              ChooseThreeDeeModel.Send.Click;
              p_EventSelected:= NoEvent;
            end
            else if  p_KeyList[0] = COMMAND_W then begin
              requestOperation:= TCreateFireOperation.Create(p_pointSelected,3);
              parser:= TMSOperationParser.Create;
              parser.ToByteArray(requestOperation);
              if p_Socket.Connected then begin
                for I := 0 to 99 do
                  sendBuf[i]:= parser.Buffer[i];
                p_Socket.Send(sendBuf, 100, 0);
              end;
            end;
          end
          else if Length(p_KeyList) = 2 then begin

            if (p_KeyList[0] = COMMAND_A) and (p_KeyList[1] = COMMAND_S) then begin
//              showmessage('Create Model On Road');
              if not Assigned(ChooseThreeDeeModel) then
                ChooseThreeDeeModel:= TChooseThreeDeeModel.Create;
              ChooseThreeDeeModel.OnCreateModel:= MS_CreateModelClick;
              ChooseThreeDeeModel.Show;
              p_EventSelected:= NoEvent;
            end

            else if ((p_KeyList[0] = COMMAND_Q) and (p_KeyList[1] = COMMAND_A)) then begin
//              showmessage('Create Obstruction');
              if not Assigned(ConfigRoadObstruction) then
                ConfigRoadObstruction:= TConfigRoadObstruction.Create;
              ConfigRoadObstruction.OnCreateObStruction:= MS_CreateObstructionClick;
              ConfigRoadObstruction.Show;
              p_EventSelected:= NoEvent;
            end

            else if ((p_KeyList[0] = COMMAND_Q) and (p_KeyList[1] = COMMAND_D)) then begin
//              showmessage('Delete Obstruction');
              if not Assigned(DeleteRoadObstruction) then
                DeleteRoadObstruction:= TDeleteRoadObstruction.Create;
              DeleteRoadObstruction.Road:= p_RoadSelected;
              DeleteRoadObstruction.OnDeleteObstruction:= MS_DeleteObstructionClick;
              DeleteRoadObstruction.Show;
              p_EventSelected:= NoEvent;
            end;

          end;
        end;

      TerrainOperationEvent:
        begin
          if Length(p_KeyList) = 1 then begin
            if p_KeyList[0] = COMMAND_S then begin
//              showmessage('Create Model On Terrain');
              if not Assigned(ChooseThreeDeeModel) then
                ChooseThreeDeeModel:= TChooseThreeDeeModel.Create;
              ChooseThreeDeeModel.OnCreateModel:= MS_CreateModelClick;
              ChooseThreeDeeModel.Send.Click;
              p_EventSelected:= NoEvent;
            end;
          end
          else if Length(p_KeyList) = 2 then begin
            if (p_KeyList[0] = COMMAND_A) and (p_KeyList[1] = COMMAND_S) then begin
//              showmessage('Create Model On Terrain');
              if not Assigned(ChooseThreeDeeModel) then
                ChooseThreeDeeModel:= TChooseThreeDeeModel.Create;
              ChooseThreeDeeModel.OnCreateModel:= MS_CreateModelClick;
              ChooseThreeDeeModel.Show;
              p_EventSelected:= NoEvent;
            end
          end;
        end;
    end;
  end;

//==============================================================================

// ģ¼
function TModelSyncGenerator.MS_ModelOperationClick(modelInstance: IF8Instance): Boolean;
  var
    fire: IF8FireInstance;
    car: IF8MovingObjectInstance;
    roadModel: IF8RoadModelInstance;
    modelName: String;
  begin
    if supports(ModelInstance, IF8MovingObjectInstance, car) then begin
      modelName:= modelInstance.model.name;
      if (modelName[1] in ['a'..'z']) or (modelName[1] in ['A'..'Z']) then begin
        result:= true;
        Exit;
      end else
      begin
        result:= false;
        Exit;
      end;
    end;
    result:= true;
    if isNum(modelInstance.name) then begin
      p_ModelSelectedType:= 2;
      p_ModelSelected:= StrToInt(modelInstance.name);
      if supports(modelInstance, IF8FireInstance, fire) then begin
        p_ModelSelectedType:= 4;
      end;
    end else
    begin
      p_ModelSelectedType:= 1;
      p_ModelSelected:= modelInstance.ID;
      if supports(modelInstance, IF8FireInstance, fire) then begin
        p_ModelSelectedType:= 3;
      end;
      if supports(modelInstance, IF8RoadModelInstance, roadModel) then begin
        p_ModelSelectedType:= 5;
      end;
    end;
    p_ModelSelectedYawAngle:= modelInstance.yawAngle;
    p_EventSelected:= ModelOperationEvent;
  end;

// ·¼
function TModelSyncGenerator.MS_RoadOperationClick(const road: IF8Road; const distance: Double; const offset: Double; const leftSide: Boolean; const carriageway: Boolean): Boolean;
  var
    currentRoadModelInstance: IF8RoadModelInstance;
    project: IF8ProjectForRoad;
  begin
    result:= true;
    project:= ModelSyncPlugin.winRoadApplication.project;
    if (Assigned(project) and (project.numberOfThreeDModels >= 1)) then begin
      currentRoadModelInstance := project.MakeRoadModel(project.threeDModel[5]);
      currentRoadModelInstance.road := road;
      currentRoadModelInstance.distance := distance;
      currentRoadModelInstance.offset := offset;
      currentRoadModelInstance.rotate := 180;
      if leftSide then begin
        currentRoadModelInstance.placement := RoadModelPlacementType(1);
        currentRoadModelInstance.placement := RoadModelPlacementType(0);
      end else
      begin
        currentRoadModelInstance.offset:= currentRoadModelInstance.offset + 0.4;
        currentRoadModelInstance.placement := RoadModelPlacementType(0);
        currentRoadModelInstance.placement := RoadModelPlacementType(1);

      end;
      p_PointSelected:= currentRoadModelInstance.instancePosition;
      project.DeleteRoadModelInstance(currentRoadModelInstance);
    end;
    p_RoadSelected:= road;
    p_RoadDistance:= distance;
    p_EventSelected:= RoadOperationEvent;
  end;

// ¼
procedure TModelSyncGenerator.MS_TerrainOperationClick(const clickedPoint: GLPointType; const terrainTriangle: F8TriangleType; var command: ModelSelectCommandType);
  begin
    p_PointSelected:= clickedPoint;
    p_EventSelected:= TerrainOperationEvent;
  end;

// жַǷתΪ
function isnum(str:string):boolean;
  var
    i:integer;
  begin
    for i:=1 to length(str) do
      if not (str[i] in ['0'..'9']) then
      begin
        result:=false;
        exit;
      end;
    result:=true;
  end;

end.
