unit MS_ServerForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, ModelSyncThread;

type
  TModelSyncServerForm = class(TForm)
    RunServer: TButton;
    ELocalPort: TEdit;
    ELocalIp: TEdit;
    Label6: TLabel;
    Label5: TLabel;
    procedure RunServerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FThread: TMSServerThread;
  public
    { Public declarations }
  end;

var
  ModelSyncServerForm: TModelSyncServerForm;

implementation

{$R *.dfm}

procedure TModelSyncServerForm.FormCreate(Sender: TObject);
  begin
    FThread:= nil;
  end;

procedure TModelSyncServerForm.FormDestroy(Sender: TObject);
  begin
    if Assigned(FThread) then begin
      FThread.Terminate;
      sleep(100);
      FThread.SocketHandle.Close;
      FreeAndNil(FThread);
    end;
  end;

procedure TModelSyncServerForm.RunServerClick(Sender: TObject);
  var
    LocalHost: AnsiString;
    LocalPort: AnsiString;
  begin
    if RunServer.Caption = 'run' then
      begin
        LocalHost:= Trim(ELocalIp.Text);
        LocalPort:= Trim(ELocalPort.Text);
        if (ELocalIp.Text <> '') and (ELocalPort.Text <> '') then begin
          FThread:= TMSServerThread.Create(LocalHost, LocalPort, true);
          if FThread.SocketHandle.Listening then begin
            FThread.Resume;
          end else
          begin
            showmessage('failed, try again!');
            FThread.Terminate;
            sleep(100);
            FThread.SocketHandle.Close;
            FreeAndNil(FThread);
            Exit;
          end;
          RunServer.Caption:= 'stop';
        end;
      end
    else if RunServer.Caption = 'stop' then
      begin
        FThread.Terminate;
        sleep(100);
        FThread.SocketHandle.Close;
        FreeAndNil(FThread);
        RunServer.Caption:= 'run';
      end;
  end;

end.
